// Helper classes:

var cqrItemClass = function(){ //cqrFileDataClass
    //Common properties
    this.filepath = "";
    this.isDir = false;
    this.id =  "";
    this.eId = this.id; //deprecated. Use id
    this.ext = '';
    this.OrderInMenu = -1;
    this.ShowInMenu = true;
    this.parent = "";
    this.blocked = false;
    this.CachedAtLevel = 0;
    //Plugin specific propertes
    this.PluginType = '';
    this.iconpath = "";
    this.dt = '';
    this.Title = "";
    this.Action = "";
    this.Method = "";
    this.referrer = "";
    this.opentarget = "";
    this.openwin="";
    this.forcein ="";
    this.Desc =  "";
    this.qcharset = "UTF-8";
    this.showif = "";
    this.sitarget = "[:selection]";
    this.si_compiled = new Object;
    this.lastmatch = [];
    this.IsMalformed = false;
    this.Diagnosis = '';
    this.Inputs = null;
    this.raw_data = '';
    this.raw_icon = '';
    this.InputsParsedFromUrlTemplate = false;
    //Dir specific properties
    this.files_count = 0;
    this.dirs_count = 0;
    this.files = new Array();

    this._prefsStoredInFF = function(){
        // Define plugin properties that should be 
        // stored to/restored from FF registry
        prefs = new Object();
        prefs['ShowInMenu'] = this.ShowInMenu;
        prefs['OrderInMenu'] = this.OrderInMenu;
        return prefs;
    }
    
    this._clone = function(){
        var NewObj = new Object();
        for (var oP in this) NewObj[oP]=this[oP];
        //NewObj.eId=NewObj.id;
        return NewObj;
    }
  
    this._StoreInput = function(inp){
        lst = new Object();
        inobj = new Object();
        inobj.name = String(inp.name);
        inobj.value = String(inp.value);
        inobj.isEditable = false; //temporary value. Will be set in co-unit's process()
        if (inp.label) {inobj.label=inp.label} else {inobj.label=""};
        if (inp.grouptitle) {inobj.grouptitle=inp.grouptitle} else {inobj.grouptitle=""};
        inobj.priority = String(inp.priority);
        ItemName = inp.name;
        //ItemName = String(inp.priority);
    
        if (this.Inputs!=null){
            if (this.Inputs[ItemName]){
                if (!this.Inputs[ItemName].list){
                  this.Inputs[ItemName].list = new Object();
                  this.Inputs[ItemName].list[this.Inputs[ItemName].def.priority] = this.Inputs[ItemName].def;
                }
                this.Inputs[ItemName].list[inp.priority] = inobj;
            }else{
                this.Inputs[ItemName] = new Object();
                this.Inputs[ItemName] = inobj;
                //this.Inputs[ItemName].def = new Object();
                this.Inputs[ItemName].def = this.clone_other(inobj); //inobj;
                //this.Inputs[ItemName].list = new Object();
                //this.Inputs[ItemName].list[inp.priority] = inobj;
            }
        }else{
            this.Inputs = new Object();
            this.Inputs[ItemName] = new Object();
            this.Inputs[ItemName] = inobj;
            //this.Inputs[ItemName].def = new Object();
            this.Inputs[ItemName].def = this.clone_other(inobj);
        }
    }
    
    this.clone_other = function(oldObj){
        newObj = new Object();
        for (each in oldObj) newObj[each] = oldObj[each];
        return newObj;
    }
}

// File system and cache factory. To store and manage plugins dirs/files,
// with primitive cache functions
var cqrFS = {
    files: new Array(), // holds cqrItemClass objects of all plugin dirs&files
    //cachedFiles: [], // holds cqrItemClass objects of all plugin dirs&files
    cachedDirs: new Array(), // hash of dir_path:(file_objects_array)
    cachedItems: [],
    sourceLastState: [], // hash of all plugins_paths:lastmodifyed_time. Used for monitoring changes in plugin dirs
    
    path_delim: '',
    //sourceCurState: [], // 
    maxFileSize: 100111, // (in bytes) files over maxFileSize will be ignored
    cacheLevel: 0,
                //Levels are:
                //0 - don't cache, re-read plugins from disk every time 
                //1 - cache only file attributes (paths, filenames etc) XXX: Not implemented!
                //2 - Files: parse & cache raw file data.
                //3 - read plugins from disk only once, then use cache
    usrMenuRootDir: '',
    sysMenuRootDir: '',
    ffSearchDir: '',
    ffUserSearchDir: '',
    menuRootId: 'conquery-menu-root',
    reDotsNStuff: /[\.\'\\\/]/ig,
    reDoubleSlash: /\\\\/ig,
    
    init: function cqrFS_init(){
        var platform = new String(navigator.platform);
        if(platform.search(/Win/) != -1) {
            cqrFS.path_delim = '\\';
        } else {
            cqrFS.path_delim = '/';
        }
        
        if (!cqrEnv.PlugsDir) {
            cqrLog.warn('Sys plug dir not set! Will try to detect Firefox search dir');
            cqrEnv.PlugsDir = cqrFS.getFFSearchDir();
        }
        if (!cqrEnv.PlugsDir2) {
            cqrLog.warn('Usr plug dir not set! Will try to detect Profile search dir');
            cqrEnv.PlugsDir2 = cqrFS.getFFUserSearchDir();
        }
        cqrFS.sysMenuRootDir = cqrFS.fixEndSlash(cqrEnv.PlugsDir);
        cqrFS.usrMenuRootDir = cqrFS.fixEndSlash(cqrEnv.PlugsDir2);
        
        cqrLog.debug('FS Factory updated.');
    },
    
    add: function(FileData){
    },
    
    clear: function(){
        //cqrFS.cachedFiles = [];
        //cqrFS.cachedDirs = [];
        cqrFS.cachedItems = [];
        cqrLog.debug('Cache have been flushed!');
    },
    
    setItemProp: function(id, prop, val, save){
        cqrFS.cachedItems[id][prop] = val;
        if (save) cqrPref.savePlugin(id);
    },
    
    getIndexedDirEntries: function getDirIndexedEntries(dirId){
        indexedArray = new Array();
        entries = cqrFS.getDirEntries(dirId);
        for (entry in entries){
            indexedArray.push(entries[entry]);
        }
        indexedArray.sort(cqrFS.sortFunction);
        return indexedArray;
    },
    
    sortFunction: function(a, b){
        return a.OrderInMenu - b.OrderInMenu;
    },
    
    getDirEntries: function getDirEntries(dirId){
        entries = [];
        cqrTimer.start('getdir');
        if (dirId == cqrFS.menuRootId) {
            cqrLog.debug('Menu root folder requested.');
            usrId = cqrFS.composeId(cqrFS.usrMenuRootDir);
            sysId = cqrFS.composeId(cqrFS.sysMenuRootDir);
            
            cqrFS.updateDirCache(usrId, false);
            cqrFS.updateDirCache(sysId, false);
            
            for (entry in cqrFS.cachedItems[usrId].files){
                e = cqrFS.cachedItems[usrId].files[entry];
                entries[e.id] = e;
            }
            for (entry in cqrFS.cachedItems[sysId].files){
                e = cqrFS.cachedItems[sysId].files[entry];
                entries[e.id] = e;
            }
            cqrFS.cachedItems[sysId].parent = cqrFS.menuRootId;
            cqrFS.cachedItems[usrId].parent = cqrFS.menuRootId;
        } else {
            cqrLog.debug('Requested menu folder: ' + dirId);
            cqrFS.updateDirCache(dirId, false);
            for (entry in cqrFS.cachedItems[dirId].files){
                e = cqrFS.cachedItems[dirId].files[entry];
                entries[e.id] = e;
                //cqrLog.debug('Entry passed: ' + e.filepath);
            }
        }
        return entries;
    },

    getCachedFile: function(id){
        //XXX: Ok, will trust to cache for now
        return cqrFS.cachedItems[id];
    },
    
    updateDirCache: function updateDirCache(dir_id, force_read){
        dir_path = cqrFS.decomposeId(dir_id);
        var dir = null;
        if ((cqrFS.cachedItems[dir_id] == null) || (cqrFS.cachedItems[dir_id].CachedAtLevel < 2) || (force_read)){
            //dir doesn't cached
            dir = cqrFS.readDir(dir_path);
            if (dir == null) { 
                cqrLog.debug(dir_path + '\n not found. Removed from cache.');
                //XXX this will not splice by str id!
                //cqrFS.cachedItems.splice(dir_id);
                return null;
            }
            //Caching dir:
            dir.CachedAtLevel = 2;
            cqrFS.cachedItems[dir.id] = dir;
            cqrPref.updatePlugin(dir.id);

            //Making links from cachedItems[id] to all of the
            //files inside dir objects - to build "plain"
            //cache with all of the items in it's root:
            for (file in dir.files) {
                cqrFS.cachedItems[dir.files[file].id] = dir.files[file];
                cqrPref.updatePlugin(dir.files[file].id);
            }
            //cqrLog.info(dir_path + '\n cached');
            return dir;
        } else {
            //dir cached
            if (cqrFS.cacheLevel > 2) {
                cqrLog.info(cqrFS.cachedItems[dir_id].filepath + ' Cached at level ' + cqrFS.cachedItems[dir_id].CachedAtLevel + '. Got from cache.')
                return cqrFS.cachedItems[dir_id];
            } else {
                //XXX: need functionality to detect file changes at cache level 2 -
                //to reread files and dirs ONLY when its state changes.
                //Until then we will always reread dirs except level 3
                return cqrFS.updateDirCache(dir_id, true);
            }
        }
    },

    sourceStateChanged: function sourceStateChanged(curStateArr){
        var rval = false;
        var lastcnt = 0;
        var curcnt = 0;
        
        for (each in cqrFS.sourceLastState) { lastcnt+=1 }
        for (each in curStateArr) { curcnt+=1 }
        
        if (lastcnt != curcnt) {
            return true;
        } else {
            for (each in curStateArr) {
                if (curStateArr[each] != cqrFS.sourceLastState[each]) { 
                    rval = true;
                    break;
                }
            }
        }
        return rval;
    },
    
    readFile: function readFile(fileNameOrObject) {
        var MODE_RDONLY = 0x01;
        var PERM_IRUSR = 00400;
        var file = new Object();
        
        try {        
            if (fileNameOrObject.constructor.toString().indexOf("String") > -1){
                file = Components.classes["@mozilla.org/file/local;1"].
                       createInstance(Components.interfaces.nsILocalFile);
                file.initWithPath(fileNameOrObject);
            } else {
                file = fileNameOrObject;
            }
            
            if (file.exists() && file.isReadable()) {
                var is = Components.classes["@mozilla.org/network/file-input-stream;1"].
                         createInstance(Components.interfaces.nsIFileInputStream);
                is.init(file, MODE_RDONLY, PERM_IRUSR, 0);
                var sis = Components.classes["@mozilla.org/scriptableinputstream;1"].
                    createInstance(Components.interfaces.nsIScriptableInputStream);
                sis.init(is);
                var data = sis.read(sis.available());
                sis.close();
                is.close();
                //return data;
                //thanks to Kuang-che Wu for UTF patch, found here:
                //http://www.csie.ntu.edu.tw/~r92030/project/patches.html
                try{
                    var uc = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].
                    createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
                    uc.charset = "UTF-8";
                    return uc.ConvertToUnicode(data);
                }catch(er){
                    cqrLog.warn(file.path + " cannot be converted to UTF! Passed as is.");
                    return data;
                }
            } else {
                cqrLog.err(file.path + " cannot be read!");
                return null;
            }
        } catch (err) {
            cqrLog.err(file.path + ' read error!', err);
        }
        return null;
    },
    
    
    readDir: function readDir(dirname, recursive){
        // XXX should we limit dir depth?
        var dirObj = new cqrItemClass();
        var items = new Object();
        var parts = dirname.split(cqrFS.path_delim);
        var files_total = 0;
        var errors_total = 0;

        try{
            var dir = Components.classes["@mozilla.org/file/local;1"].
                       createInstance(Components.interfaces.nsILocalFile);
            dir.initWithPath(dirname);        
            if (dir.isDirectory()) {
                dirObj.id = cqrFS.composeId(dir.path);
                dirObj.Title = dir.leafName;dirObj
                dirObj.filepath = dir.path;
                dirObj.isDir = true;
                dirObj.dt = dir.lastModifiedTime;
                try {
                    dirObj.parent = cqrFS.composeParentId(dir.parent.path);
                } catch(err) {
                    dirObj.parent = cqrFS.composeParentId(dir.path);
                }
                try {
                    items = dir.directoryEntries;
                } catch(err) {
                    cqrLog.err('Problems reading dir: ' + dirname, err);
                    cqrLog.info(dirObj.filepath + ' done. Cached ' + dirObj.files_count + ' out of ' + files_total + ' with 1 error.');
                    return dirObj;
                }
            } else {
                cqrLog.warn("Can't read directory: " + dirname);
                return null;
            }
            
            items.QueryInterface(Components.interfaces.nsISimpleEnumerator);
            while (items.hasMoreElements()) {
                var i = items.getNext();
                var itemObj = new cqrItemClass(); //f
                i.QueryInterface(Components.interfaces.nsIFile);
                if (!i.isDirectory()){
                    var fn = i.leafName;
                    var fx = fn.substr(fn.length - 4, fn.length).toLowerCase();
                    if ((fx == '.cqr')||(fx == '.src')||(fx == '.xml')){
                        files_total += 1;
                        var fdata = cqrFS.readFile(i);
                        if (fdata.length < 7) {
                            cqrLog.warn(i.path + ' is empty. Skipped.');
                            errors_total += 1;
                            continue;
                        }

                        //var uc = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].
                        //createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
                        //uc.charset = "UTF-8";
                        //itemObj.filepath = uc.ConvertToUnicode(i.path);
                        //itemObj.filepath += uc.Finish();
                        itemObj.filepath = i.path;
                        itemObj.id = cqrFS.composeId(i.path);
                        itemObj.eId = itemObj.id; //eId - Deprecated prop!
                        itemObj.raw_data = fdata;
                        itemObj.ext = fx;
                        itemObj.isDir = false;
                        itemObj.parent = cqrFS.composeParentId(dirObj.filepath);

                        itemObj.dt = i.lastModifiedTime;

                        if (fx == '.xml') {
                            itemObj = cqrParser.parseXML(fdata, itemObj, false);
                        } else {
                            itemObj = cqrParser.parseMycroft(fdata, itemObj, false);
                        }
                        if (itemObj.IsMalformed){
                            cqrLog.err(i.path + 'Parser failed!', itemObj.Diagnosis);
                            errors_total += 1;
                            continue;
                        }
                        
                        itemObj.iconpath = cqrFS.guessIconSource(itemObj);
                        itemObj.CachedAtLevel = 2;
                        dirObj.files.push(itemObj);
                        
                        //Caching file data
                        //cqrFS.cachedItems[parsed_data.id] = dirObj.files[dirObj.files.length];
                        //cqrFS.cachedItems[parsed_data.id] = 1;
                        dirObj.files_count += 1;
                    }
                } else {
                    itemObj.id = cqrFS.composeId(i.path);
                    itemObj.eId = itemObj.id; //deprecated, use id
                    itemObj.Title = i.leafName;
                    itemObj.filepath = i.path;
                    itemObj.dt = i.lastModifiedTime;
                    itemObj.parent = cqrFS.composeParentId(dirObj.filepath);
                    itemObj.isDir = true;
                    itemObj.CachedAtLevel = 1;
                    dirObj.files.push(itemObj);
                    dirObj.dirs_count += 1;
                }
            }
        }catch(err){cqrLog.err("Unexpected", err)}
        //result.data = arr;
        cqrLog.info(dirObj.filepath + ' done. Stats: \nPlugin files: ' + dirObj.files_count + ' out of ' + files_total + '\nDirs: ' + dirObj.dirs_count + '\nParse errors: ' + errors_total + '\nTime: ' + cqrTimer.stop('getdir'));
        return dirObj;
    },
    
    create: function(isDir, path) {
        var name = window.prompt(cqrMess.GetStringFromName(isDir ? "cqr.FS.dirName" : "cqr.FS.fileName"), "", cqrMess.GetStringFromName(isDir ? "cqr.FS.newDir" : "cqr.FS.newFile"));
        
        if (!name || !path) {
            return null;
        }
        
        //var dir = this.init(localTree.constructPath(gLocalPath.value, name));
        var dir = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
        dir.initWithPath(path+this.path_delim+name);
        
        try {
            dir.create(isDir ? Components.interfaces.nsILocalFile.DIRECTORY_TYPE : Components.interfaces.nsILocalFile.NORMAL_FILE_TYPE,
                     isDir ? 0755 : 0644);
        } catch (err) {
            cqrLog.err('Failed!', err);
            return null;
        }
        
        return dir;
    },
    
    delFile: function(itemId){
        var item = cqrFS.cachedItems[itemId];
        if (!item) return;
        var confirm = window.confirm(cqrMess.GetStringFromName('cqr.FS.deleteQuestion') + '\n"' +
                                 item.filepath + '"?\n\n' +
                                 cqrMess.GetStringFromName('cqr.FS.realWarning'))
        if (!confirm) return;
        var fsItem = Components.classes["@mozilla.org/file/local;1"].
                     createInstance(Components.interfaces.nsILocalFile);
        fsItem.initWithPath(item.filepath);
        if (!fsItem.exists()) {
            cqrLog.err('File does not exists.');
            return;
        }
        try {
            fsItem.remove(true);
            return true;
        } catch(err) {
            cqrLog.err("Can't remove file or folder", err);
            return true;
        }
    },
    
    copy: function(itemId){},
    
    move: function(itemId, newDirId, copy){
        if (newDirId == cqrFS.menuRootId) {
            var newDir = {filepath: cqrFS.usrMenuRootDir || cqrFS.sysMenuRootDir};
        } else {
            var newDir = cqrFS.cachedItems[newDirId];
        }
        var item = cqrFS.cachedItems[itemId];
        
        if (!item || !newDir) return false;
        
        var fsItem = Components.classes["@mozilla.org/file/local;1"].
                     createInstance(Components.interfaces.nsILocalFile);
        fsItem.initWithPath(item.filepath);
        
        var fsNewDir = Components.classes["@mozilla.org/file/local;1"].
                     createInstance(Components.interfaces.nsILocalFile);
        fsNewDir.initWithPath(newDir.filepath);

        if (!fsItem.exists()) {
            cqrLog.err('File does not exists.', item.filepath);
            return;
        } else if (!fsNewDir.exists()){
            cqrLog.err('Dir does not exists.', newDir.filepath);
            return;
        }
        
        var destFile = fsNewDir.path + cqrFS.path_delim + fsItem.leafName;
        var fsDestFile = Components.classes["@mozilla.org/file/local;1"].
                     createInstance(Components.interfaces.nsILocalFile);
        fsDestFile.initWithPath(destFile);
        if (fsDestFile.exists()) {
            var confirm = window.confirm(cqrMess.GetStringFromName('cqr.FS.overwriteQuestion') + '\n"' +
                                     fsDestFile.path + '"\n\n' +
                                     cqrMess.GetStringFromName('cqr.FS.realWarning'))
            if (!confirm) return;
        }
        
        if (!fsItem.isDirectory()){
            try {
                if (copy) {
                    fsItem.copyTo(fsNewDir, null);
                } else {
                    fsItem.moveTo(fsNewDir, null);
                }
                return true;
            } catch(err) {
                cqrLog.err("Can't move file!", err);
                return true;
            }
        } else {
            //not implemented
            return true;
        }
    },
    
    guessIconSource: function(itemObj){
        if (itemObj.iconpath) return itemObj.iconpath;
        if (itemObj.IconRawData) return '';
        fileIcon = cqrFS.tryPluginIconFile(itemObj.filepath);
        if (fileIcon) return fileIcon;
        //XXX we need option to highlight context plugins by 
        //special icon or by text style (color)
        //until then we can't manage http icos
        if (itemObj.showif) return '';
        if (!cqrEnv.HTTPIcon) return '';
        url = cqrFS.url2host(itemObj.Action);
        if (url) return url + '/favicon.ico';
        return '';
    },
    
    tryPluginIconFile: function(plugpath){
        var icon_gif = plugpath.substr(0, plugpath.length -4) + ".gif";
        var icon_png = plugpath.substr(0, plugpath.length -4) + ".png";
        
        var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        
        file.initWithPath(icon_gif);
        if (file.exists()) {
            return 'file://'+icon_gif;
        } else {
            file.initWithPath(icon_png);
            if (file.exists()) {
                return 'file://'+icon_png;
            } else {
                return "";
            }
        }
    return '';
    },

    composeParentId: function composeId(item_path){
        if ((item_path == cqrFS.usrMenuRootDir) || (item_path == cqrFS.sysMenuRootDir)) {
            return cqrFS.menuRootId;
        } else {
            return cqrFS.composeId(item_path)
        }
    },

    composeId: function composeId(item_path){
        if (item_path == '') return '';
        var id = '';
        item_path = encodeURI(item_path);
        try {
            id = btoa(item_path);
        } catch(er) {
            try {
                id = window.btoa(item_path);
            } catch(err) {
                cqrLog.warn('BASE64 is not supported by your platform. Will use dummy encode');
                id = cqrFS.dummyComposeId(item_path);
            }
        } 
        return id;
    },

    decomposeId: function decomposeId(id){
        if (id == cqrFS.menuRootId) return cqrFS.menuRootId;
        var item_path = '';
        try {
            item_path = atob(id);
            item_path = decodeURI(item_path);
        } catch(er) {
            try {
                item_path = window.atob(id);
            } catch(err) {
                cqrLog.err('BASE64 is not supported by your platform. Will use dummy decode', err);
                item_path = cqrFS.dummyDecomposeId(id);
            }
        } 
        return item_path;
    },
    
    dummyComposeId: function(item_path){
        var id = encodeURI(item_path);
        id = id.replace(/\./g, 'conquery-dot-encode');
        return id;
    },
    
    dummyDecomposeId: function(id){
        if (id == cqrFS.menuRootId) return cqrFS.menuRootId;
        var item_path = id.replace(/conquery-dot-encode/g, '.');
        item_path = decodeURI(item_path);
        return item_path;
    },

    getFFSearchDir: function cqrFS_getFirefoxSearchDir(){
        try {
            var gDirServiceProp = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
            var gChromeDir = gDirServiceProp.get("AChrom",Components.interfaces.nsIFile);
            var patharr = gChromeDir.path.split(cqrFS.path_delim);
            patharr[patharr.length-1]="searchplugins";
            var searchDirPath = patharr.join(cqrFS.path_delim);
            var searchDir = Components.classes["@mozilla.org/file/local;1"].
                           createInstance(Components.interfaces.nsILocalFile);
            searchDir.initWithPath(searchDirPath);
            if (searchDir.isDirectory()) {
                cqrLog.info('Firefox search dir detected: ' + searchDir.path);
                return searchDir.path;
            } else {
                cqrLog.warn('Cant use FireFox search dir: ' + searchDir.path);
                return '';
            }
        } catch(err) {
            cqrLog.warn('Cant detect FireFox search dir!\n' + err);
            return '';
        }
    },
    
    getFFUserSearchDir: function getFirefoxProfileSearchDir(){
        try {
            var cqrProfileDir = Components.classes["@mozilla.org/file/directory_service;1"]
                                 .getService(Components.interfaces.nsIProperties)
                                 .get("ProfD", Components.interfaces.nsIFile);
            var userDirPath = cqrProfileDir.path + cqrFS.path_delim + 'searchplugins';
            var userDir = Components.classes["@mozilla.org/file/local;1"].
                       createInstance(Components.interfaces.nsILocalFile);
            userDir.initWithPath(userDirPath);
            if (userDir.isDirectory()) {
                cqrLog.info('Profile search dir detected: ' + userDirPath);
                return userDirPath;
            } else {
                cqrLog.warn('Cant use profile search dir: ' + userDirPath);
            }
        } catch(err) {
            cqrLog.warn('Cant detect profile search dir', err);
            return '';
        }
    },

    url2host: function(url){
        //XXX add 'ftp://' pattern also!
        var re = new RegExp("^http://([^/]*)","ig");
        retmp = re.exec(url);
        if (retmp) {
            return retmp[0];
        } else {
            return "";
        }
    },

    fixEndSlash: function(path){
        return (path.substr(-1,1) == cqrFS.path_delim ? path.substr(0,path.length-1) : path);
    },
}

cqrFS.init();
