var cqrEnv = {
    PlugsDir: '',
    PlugsDir2: '',
    UseHotMenu: false,
    UseCtrlForHM: false,
    UseMiddleClickForHM: false,
    MiddleClickDelayms: 450,
    MiddleClickHidems: 700,
    HTTPIcon: true,
    OpenRes: 'tab_bg',
    HideFromTools: false,
    ShowCSPInMainMenu: true,
    HideQueryTo: false,
    MainContextLimit: 0,
    LogLevel: 0,
    AllowedMIMETypesInOrder: "text/html, application/xhtml+xml",
    ParseNonConQueryUrlTemplate: true,
    ShowQueryDumpButton: false,
    QueryConfigWidth: '300px',
    
    _getAll: function(){
        env = [];
        for (each in cqrEnv) if (each.substr(0,1) != '_') env[each]=cqrEnv[each];
        return env;
    },
    
    _setOne: function(prop, val){
        cqrEnv[prop] = val;
    },
}

const cqrPrefListener = {
  domain: "extensions.conquery.Main.",
  observe: function(subject, topic, prefName) {
    if (topic != "nsPref:changed") return;
    try {cqrPref.updateMain()}catch(err){}
  }
};


var cqrPref = {
    rootId: 'extensions.conquery.',
    root: null,
    prefService: Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefService),
    globalPrefs: null,

    init: function cqrPref_init(){
        cqrPref.root = cqrPref.prefService.getBranch(cqrPref.rootId);

        globalPrefs = cqrPref.prefService.getBranch(null);
        prefListener = globalPrefs.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
        prefListener.addObserver(cqrPrefListener.domain, cqrPrefListener, false);

        var main_props = cqrEnv._getAll();
        for (prop in main_props){
            var val = cqrPref.fetchOne('Main.'+prop, main_props[prop]);
            cqrEnv[prop] = val;
        }
    },

    updateMain: function cqrPref_UpdateMain(){
        var main_props = cqrEnv._getAll();
        for (prop in main_props){
            var val = cqrPref.fetchOne('Main.'+prop, main_props[prop]);
            cqrEnv[prop] = val;
        }
        cqrLog.init();
        cqrFS.init();
        cqrParser.init();
    },

    saveMain: function cqrPref_SaveMain(){
        var main_props = cqrEnv._getAll();
        var val = '';
        for (prop in main_props){
            val = cqrPref.saveOne('Main.'+prop, main_props[prop]);
        }
    },

    updatePlugin: function(plugId){
        var plug_props = cqrFS.cachedItems[plugId]._prefsStoredInFF();
        for (prop in plug_props){
            var val = cqrPref.fetchOne('Items.'+plugId+'.'+prop, plug_props[prop]);
            cqrFS.cachedItems[plugId][prop] = val;
        }
    },
    
    savePlugin: function(plugId){
        var plug_props = cqrFS.cachedItems[plugId]._prefsStoredInFF();
        for (prop in plug_props){
            cqrPref.saveOne('Items.'+plugId+'.'+prop, plug_props[prop]);
        }
    },
    
    fetchOne: function(name, defaultVal){
        if (cqrPref.root.prefHasUserValue(name)) {
            var type = cqrPref.root.getPrefType(name);
            if (type & 128) {
                return cqrPref.root.getBoolPref(name);
            } else if (type & 64) {
                return cqrPref.root.getIntPref(name);
            } else if (type & 32) {
                return cqrPref.root.getCharPref(name);
            } else {
                return defaultVal;
            }
        } else {
            return defaultVal;
        }
    },

    saveOne: function(name, val){
        type = val.constructor.toString();
        if (type.indexOf("Boolean") > -1){
            cqrPref.root.setBoolPref(name, val);
            return;
        } else if (type.indexOf("Number") > -1){
            cqrPref.root.setIntPref(name, val);
            return;
        } else {
            cqrPref.root.setCharPref(name, val);
            return;
        }
    },
}

cqrPref.init();
